"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DLCommonsModule = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const sessions_service_1 = require("./services/sessions.service");
const mongoose_1 = require("@nestjs/mongoose");
const env_vars_const_1 = require("./models/consts/env-vars.const");
const session_schema_1 = require("./models/schemas/session.schema");
const axios_1 = require("@nestjs/axios");
const dictionaries_service_1 = require("./services/dictionaries.service");
let DLCommonsModule = class DLCommonsModule {
};
exports.DLCommonsModule = DLCommonsModule;
exports.DLCommonsModule = DLCommonsModule = __decorate([
    (0, common_1.Module)({
        imports: [
            config_1.ConfigModule,
            axios_1.HttpModule,
            mongoose_1.MongooseModule.forRootAsync({
                connectionName: 'sessions-store',
                useFactory: async (configService) => ({
                    uri: configService.get(env_vars_const_1.DL_SESSIONS__MONGO__CS),
                }),
                inject: [config_1.ConfigService],
            }),
            mongoose_1.MongooseModule.forFeature([{ name: session_schema_1.Session.name, schema: session_schema_1.SessionSchema }], 'sessions-store'),
        ],
        controllers: [],
        providers: [sessions_service_1.SessionsService, dictionaries_service_1.DictionariesService],
        exports: [sessions_service_1.SessionsService, dictionaries_service_1.DictionariesService],
    })
], DLCommonsModule);
//# sourceMappingURL=dl-commons.module.js.map