import { HttpService } from '@nestjs/axios';
import { ConfigService } from '@nestjs/config';
import { ISession } from '../models/interfaces/session.interface';
import { Model } from 'mongoose';
import { SessionDocument } from '../models/schemas/session.schema';
import { Types } from 'mongoose';
export declare class SessionsService {
    private readonly _sessionModel;
    private readonly _httpService;
    private readonly _configService;
    private _baseUrl;
    constructor(_sessionModel: Model<SessionDocument>, _httpService: HttpService, _configService: ConfigService);
    create(userId: string | Types.ObjectId, userAgent: string, ip: string): Promise<ISession>;
    read(token: string): Promise<ISession>;
}
