"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SMTPService = void 0;
const axios_1 = require("@nestjs/axios");
const config_1 = require("@nestjs/config");
const rxjs_1 = require("rxjs");
const common_1 = require("@nestjs/common");
const rest_wrapper_class_1 = require("../models/dtos/wrappers/rest-wrapper.class");
let SMTPService = class SMTPService {
    constructor(_httpService, _configService) {
        this._httpService = _httpService;
        this._configService = _configService;
        this._baseUrl = this._configService.getOrThrow('DL_SMTP__REST__BASE_URL');
    }
    async send(subject, from, to, html, profileId) {
        const requestBody = {
            data: {
                from,
                to: [to],
                subject,
                html,
            },
        };
        const response$ = this._httpService.post(`${this._baseUrl}/v1/emails/send`, requestBody, { params: { profileId } });
        const response = await (0, rxjs_1.firstValueFrom)(response$);
        if (response.data.errors) {
            throw new rest_wrapper_class_1.RESTError('smtp_api_error', response.data.errors);
        }
        if (!response.data || !response.data.result) {
            throw new rest_wrapper_class_1.RESTError('smtp_api_error', 'empty response');
        }
        return response.data.result.data;
    }
    send$(subject, from, to, html, profileId) {
        const requestBody = {
            data: {
                from,
                to: [to],
                subject,
                html,
            },
        };
        const response$ = this._httpService.post(`${this._baseUrl}/v1/emails/send`, requestBody, { params: { profileId } });
        return response$.pipe((0, rxjs_1.map)((response) => {
            if (response.data.errors) {
                throw new rest_wrapper_class_1.RESTError('smtp_api_error', response.data.errors);
            }
            if (!response.data || !response.data.result) {
                throw new rest_wrapper_class_1.RESTError('smtp_api_error', 'empty response');
            }
            return response.data.result.data;
        }), (0, rxjs_1.catchError)((e) => {
            throw new rest_wrapper_class_1.RESTError('smtp_api_error', e);
        }));
    }
};
exports.SMTPService = SMTPService;
exports.SMTPService = SMTPService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [axios_1.HttpService, config_1.ConfigService])
], SMTPService);
//# sourceMappingURL=smtp.service.js.map