import { ValidationArguments, ValidatorConstraint, ValidatorConstraintInterface } from 'class-validator';

@ValidatorConstraint({ name: 'IsMapOfStrings', async: false })
export class IsMapOfStringsConstraint implements ValidatorConstraintInterface {
    validate(value: any, args: ValidationArguments): boolean {
        if (!value || typeof value !== 'object') {
            return false;
        }

        for (let key in value) {
            if (typeof value[key] !== 'string') {
                return false;
            }
        }

        return true;
    }

    defaultMessage(args: ValidationArguments): string {
        return `${args.property} must be a map object with string values.`;
    }
}
