import { Schema, Prop, SchemaFactory } from '@nestjs/mongoose';
import { ContactType } from '../../enums/contact-type.enum';
import { IContact } from '../../interfaces/contact.interface';
import { Identifable } from '../identifable.schema';
import { HydratedDocument } from 'mongoose';

@Schema({})
export class Contact extends Identifable implements IContact {
    @Prop({ required: true, enum: ContactType, type: String })
    type: ContactType;

    @Prop({ type: String, required: true })
    value: string;

    @Prop({ type: Boolean, default: false })
    primary: boolean;

    @Prop({ type: Boolean, default: false })
    verified: boolean;
}

export const ContactSchema = SchemaFactory.createForClass(Contact);
export type ContactDocument = HydratedDocument<Contact>;
